<template>
  <div class="all-tab-container">
    <div class="filter-group-contianer flex row content-end">
      <div class="item">
        <el-select
          v-model="lesson_id"
          placeholder="选择班级"
          @change="fetchAnswerSheetList"
        >
          <el-option :value="null" :label="'无选择班级'"></el-option>
          <el-option
            v-for="(lesson, index) in lessons"
            :key="index"
            :value="lesson.id"
            :label="lesson.name"
          ></el-option>
        </el-select>
      </div>
    </div>
    <PageList
      :items="items"
      v-if="!showDetail"
      @check="data => showDetailPage(data)"
    ></PageList>
    <ExperimentMark
      v-if="showDetail"
      :markData="markData"
      @commitMark="commitMark"
      @cancel="cancalMark"
    ></ExperimentMark>
  </div>
</template>

<script>
import { answersheets, lessons } from "@/api";
import PageList from "./components/pageList";
import ExperimentMark from "./experimentMark";
import dayjs from "dayjs";
import MessagesDialog from "@/mixins/messagesDialog";

export default {
  name: "allTab",
  components: { PageList, ExperimentMark },
  data() {
    return {
      items: [],
      lessons: [],
      showDetail: false,
      lesson_id: null,
      markData: {
        account: undefined,
        answers: undefined,
        createdAt: undefined,
        isEnd: undefined,
        name: undefined,
        score: undefined,
        total: undefined,
        updatedAt: undefined
      }
    };
  },
  mixins: [MessagesDialog],
  methods: {
    async fetchLessonsList() {
      let result = await lessons.list();
      this.lessons = result.items;
    },
    async fetchAnswerSheetList() {
      let params = {
        filters: {
          include: ["account"],
          order: [
            {
              key: "createdAt",
              sort: "desc"
            }
          ]
        }
      };
      if (this.lesson_id !== null) {
        params.filters.where = Object.assign(
          { lesson_id: this.lesson_id },
          params.filters.where
        );
      }
      try {
        let result = await answersheets.list(params);
        result.items.forEach(item => this.answersheetFormat(item));
        this.items = result.items;
      } catch (err) {
        return this.$message({
          type: "error",
          message: "网络错误"
        });
      }
    },
    async fetchAnswerSheetItemDetail(data) {
      try {
        const res = await answersheets.detail(data.id, {
          filters: {
            include: [
              "account",
              "lab",
              {
                association: "answers",
                include: ["question"]
              }
            ]
          }
        });
        this.markData = res;
      } catch (err) {
        return this.$message({
          type: "error",
          message: "网络错误"
        });
      }
    },
    answersheetFormat(item) {
      item.name = item.account.name;
      item.createdAt = dayjs(item.createdAt).format("YYYY-MM-DD HH:mm:ss");
    },
    async showDetailPage(data) {
      await this.fetchAnswerSheetItemDetail(data);
      this.showDetail = true;
    },
    async commitMark(data) {
      const answerSheetItems = data.map(data => {
        return {
          id: data.id,
          comment: data.comment,
          score: data.score
        };
      });
      const items = {
        id: data[0].answersheet_id,
        answerSheetItems
      };
      try {
        await answersheets.update(items);
        this.successDialog("审批成功！");
        await this.fetchAnswerSheetItemDetail(items);
        this.mark = false;
        // this.markData = null;
      } catch (err) {
        await this.fetchAnswerSheetItemDetail(items);
        this.errorDialog(err);
      }
    },
    async cancalMark() {
      await this.fetchAnswerSheetList();
      this.showDetail = false;
    }
  },
  async created() {
    await this.fetchAnswerSheetList();
    await this.fetchLessonsList();
  }
};
</script>
